// 0xGG Team
// Distributed under AGPL3
//
// DESCRIPTION: The code below is basic on https://github.com/markushedvall/plantuml-encoder/blob/master/dist/plantuml-encoder.min.js. Credit to @markushedvall
// Please include the following in your index.html file
//
//   <script src="https://cdn.jsdelivr.net/npm/plantuml-encoder@1.4.0/dist/plantuml-encoder.min.js"></script>
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};

(function (mod){ //[HyperMD] UMD patched!
  /*commonjs*/  ("object"==typeof exports&&"undefined"!=typeof module) ? mod(null, exports, require("codemirror"), require("../addon/fold-code"), require("../addon/fold")) :
  /*amd*/       ("function"==typeof define&&define.amd) ? define(["require","exports","codemirror","../addon/fold-code","../addon/fold"], mod) :
  /*plain env*/ mod(null, (this.HyperMD.FoldCodeWithPlantUML = this.HyperMD.FoldCodeWithPlantUML || {}), CodeMirror, HyperMD.FoldCode, HyperMD.Fold);
})(function (require, exports, CodeMirror, fold_code_1, fold_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    CodeMirror = __importStar(CodeMirror);
    exports.PlantUMLRenderer = function (code, info) {
        var id = "_plantuml_id_" + Math.round(1e9 * Math.random()).toString(36);
        var el = document.createElement("div");
        el.style.margin = "8px";
        var encoded = window["plantumlEncoder"].encode(code);
        var url = "https://www.plantuml.com/plantuml/img/" + encoded;
        el.setAttribute("id", id);
        var img = document.createElement("img");
        img.src = url;
        el.appendChild(img);
        return {
            element: el,
            asyncRenderer: null
        };
    };
    if (window["plantumlEncoder"]) {
        CodeMirror.defineOption("plantuml", null, function (cm) {
            fold_code_1.getAddon(cm).clear("plantuml");
            fold_1.getAddon(cm).startFold();
        });
        fold_code_1.registerRenderer({
            name: "plantuml",
            pattern: /^(plantuml|puml)$/i,
            renderer: exports.PlantUMLRenderer,
            suggested: true
        });
        if (window["VICKYMD_DEBUG"]) {
            console.log("[HyperMD] PowerPack fold-code-with-plantuml loaded.");
        }
    }
    else {
        if (window["VICKYMD_DEBUG"]) {
            console.log("[HyperMD] PowerPack fold-code-with-plantuml failed to load.\nPlease include  \n\n  <script src=\"https://cdn.jsdelivr.net/npm/plantuml-encoder@1.4.0/dist/plantuml-encoder.min.js\"></script>\n\nin your HTML file");
        }
    }
});
