// 0xGG Team
// Distributed under AGPL3
//
// DESCRIPTION: This widget creates <audio> html element
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
define(["require", "exports", "react", "react-dom", "../component/widget", "../error/error"], function (require, exports, react_1, react_dom_1, widget_1, error_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    react_1 = __importDefault(react_1);
    react_dom_1 = __importDefault(react_dom_1);
    function Audio(props) {
        var attributes = props.attributes;
        return (react_1.default.createElement("span", { style: { cursor: "default" } },
            react_1.default.createElement("audio", { autoPlay: attributes["autoplay"] || attributes["autoPlay"], controls: attributes["controls"], loop: attributes["loop"], muted: attributes["muted"], style: attributes["style"] },
                "Your browser does not support the audio element.",
                react_1.default.createElement("source", { src: attributes["src"], type: attributes["type"] })),
            !props.isPreview && "🎵"));
    }
    exports.AudioWidget = function (args) {
        var el = document.createElement("span");
        if (!args.attributes["src"]) {
            return error_1.ErrorWidget(__assign(__assign({}, args), {
                attributes: { message: "Field 'src' is missing" }
            }));
        }
        react_dom_1.default.render(react_1.default.createElement(widget_1.Widget, null,
            react_1.default.createElement(Audio, { attributes: args.attributes, isPreview: args.isPreview })), el);
        return el;
    };
});
